#include<bits/stdc++.h>

using namespace std;

const int N = 1e5+1, logN = 17+1, K = 100+1;

int n, k;
int a[N];

int fl[N];
int maxtable[logN][N];
void init(){
    fl[1] = 0;
    for(int i = 2; i < N; ++i)
        fl[i] = fl[i/2]+1;
    for(int i = 0; i < n; ++i)
        maxtable[0][i] = a[i];
    for(int d = 0; d < logN-1; ++d)
        for(int i = 0; i <= n-(1<<d); ++i)
            maxtable[d+1][i] = max(maxtable[d][i], maxtable[d][i+(1<<d)]);
}

int getmax(int l, int r){ // [l, r)
    if(l >= r)
        return 0;
    int level = fl[r-l];
    return max(maxtable[level][l], maxtable[level][r-(1<<level)]);
}

int t[2*N];

int dp[N][K];

void build(int k){
    for(int i = n; i < 2*n; ++i)
        t[i] = dp[i-n][k];
    for(int i = n-1; i >= 1; --i)
        t[i] = min(t[i<<1], t[i<<1|1]);
}
int get(int l, int r){ // [l, r)
    int res = 1e9+1;
    for(l += n, r += n; l < r; l >>= 1, r >>= 1){
        if(l&1) res = min(res, t[l++]);
        if(r&1) res = min(res, t[--r]);
    }
    return res;
}

main(){
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> k;
    for(int i = 0; i < n; ++i)
        cin >> a[i];
    init();
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < k; ++j)
            dp[i][j] = 1e9+1;
    for(int i = 0; i < n; ++i)
        if(getmax(0, i+1) <= a[i])
            dp[i][0] = a[i];
    for(int j = 1; j < k; ++j){
        build(j-1);
        priority_queue<int, vector<int>, greater<int>> q;
        q.push(dp[j-1][j-1]);
        for(int i = j; i < n; ++i){
            dp[i][j] = q.top()+a[i];
            int lo = j-1,
                hi = i;
            while(lo+1 < hi){
                int mid = (lo+hi)/2;
                if(getmax(mid, i) <= a[i])
                    hi = mid;
                else lo = mid;
            }
            dp[i][j] = min(dp[i][j], get(lo, i)+a[i]);
            while(!q.empty() && q.top() < a[i])
                q.pop();
            q.push(dp[i][j-1]);
        }
    }
    int ans = 1e9+1;
    for(int i = k-1; i < n; ++i)
        if(a[i] >= getmax(i+1, n))
            ans = min(ans, dp[i][k-1]);
    cout << ans << '\n';
}

