#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int d;

bool prime(int num) {
    int sq = sqrt(num);
    if (num == 1) {
        return false;
    }
    for (int i = 2; i <= sq; ++ i) {
        if (num % i == 0)
            return false;
    }
    return true;
}

int pow(int a, int b) {
    int ans = 1;
    for (int i = 0; i < b; ++ i) {
        ans *= a;
    }
    return ans;
}

void check(int num) {
    int dub = num;
    int k = 0;
    while (dub > 0) {
        k ++;
        dub /= 10;
    }
    for (int i = d; i <= k - d; ++ i) {
        int mod = pow(10, i);
        if (num / (mod / 10) % 10 == 0) {
            continue;
        }
        if (!prime(num / mod) || !prime(num % mod)) {
            continue;
        }
        cout << num << endl;
        return;
    }
    check(num + 1);
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("StandardOutput.out", "w", stdout);
    int t, n;
    cin >> t;
    for (int i = 0; i < t; ++ i) {
        cin >> d >> n;
        int magic_num = pow(10, d - 1);
        n = max(magic_num * (magic_num * 10 + 1) + 1, n);
        check(n);
    }

}
