#include <bits/stdc++.h>

using namespace std;
#define int long long
#define pb push_back
#define mp make_pair
#define EPS 0.000000001
#define min3(a,b,c) min(min(a,b),c)
#define max3(a,b,c) max(max(a,b),c)
#define mid3(a,b,c) a+b+c-max3(a,b,c)-min3(a,b,c)

const int inf = 1e15; ///
const int mod = 1e9+7;
void print(vector<int> v){
    for(auto i:v) cout << i << " ";
    cout << "\n";
}
const int Nmax = 1e5+10;
int t[4*Nmax];
int mass[Nmax];

void build(int v,int l,int r){
    if(l > r) return;
    if(l == r){
        t[v] = mass[l];
        return;
    }
    int mid = (l+r)>>1;
    build(2*v,l,mid);
    build(2*v+1,mid+1,r);
    t[v] = max(t[2*v],t[2*v+1]);
}
void update(int v,int l,int r,int pos,int val){
    if(l > r) return;
    if(l == r){
        t[v] = val;
        return;
    }
    int mid = (l+r)>>1;
    if(pos <= mid) update(2*v,l,mid,pos,val);
    else update(2*v+1,mid+1,r,pos,val);
    t[v] = max(t[2*v],t[2*v+1]);
}
int get(int v,int l1,int r1,int l,int r){
    if(l > r || l1 > r1) return -inf;
    if(l == r && l1 ==r1) return t[v];
    int mid = (l1+r1)>>1;
    return max(get(2*v,l1,mid,l,min(mid,r)),get(2*v+1,mid+1,r1,max(mid+1,l),r));
}
signed main(){
    int n,a;
    scanf("%lld",&n);
    scanf("%lld",&a);
    for(int i = 0;i<n;i++) scanf("%lld",&mass[i]);
    build(1,0,n);
    if(a == 1){
        cout << *max_element(mass,mass+n);
        return 0;
    }
    int dp[n-1][a+1];
    int maxi = -inf;
    for(int i = 0;i<n-1;i++) for(int z =0;z<=a;z++) dp[i][z] = inf;
    for(int i = 0;i<n-1;i++){
        dp[i][0] = 0;
        maxi = max(maxi,mass[i]);
        dp[i][1] = maxi;
    }
    //for(int i = 0;i<n-1;i++) cout << dp[i][1] << " ";
    //cout << endl;
    for(int z = 2;z<=a;z++){
        for(int i = z-1;i<n-1;i++){
            dp[i][z] = inf;
            for(int j = 0;j < i;j++){
                int maxi = get(1,0,n,j+1,i);
                dp[i][z] = min(dp[i][z],maxi+dp[j][z-1]);
            }
        }
    }
    int c1 = inf;
    maxi = -1;
    for(int i = n-1;i >= (a-1);i--){
        maxi = max(maxi,mass[i]);
        c1 = min(c1,maxi+dp[i-1][a-1]);
    }
    printf("%lld",c1);
    //for(int i = 0;i<n-1;i++){
     //   for(int z = 0;z<=a;z++){
      //      cout << dp[i][z] << " ";
      //  }
      //  cout << endl;
   // }
}
